/*  This file is a part of the program DNetStats.
    DNetStats a linux qt application to monitor network and initiate 
    autoshutdown when connection is cut or idle.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef DIALOGIMPL_H
#define DIALOGIMPL_H

#include "ui_dialog.h"
# include "thread.h"
#include "shutthread.h"
//#include "ntmap.h"

 #include "netthread.h"
//
class DialogImpl : public QDialog, public Ui::Dialog
{
Q_OBJECT
public:
	DialogImpl( QWidget * parent = 0, Qt::WFlags f = 0);
	// 
	
        QString countstr,sstr,traystr,processstr;
	//QTime ctime;
         //NtMapDialog *ndialog;
         QMessageBox msgBox;
         QMessageBox msg2Box;//message box to show shutdown
	 QDateTime ctime; //shutdown time


	char buf[25];
        int buf1,buf2,ubuf1,ubuf2,i,cspeed,ucspeed,ret,ret2;
	fstream f;	
        QGraphicsScene scene;
	QFont mfont;
	QLineF line1,line2,line3,line4,line5;	
	int x1,y1,x2,y2;
	void gviewshow();
	QString spdstring,pathstr;
	bool ok,systraymsg;
	
protected:
    void closeEvent(QCloseEvent *event);
private:
    Thread threadA;
    shutthread sthread;
    int count,sysv,idlecounter;//idlecounter acts as counter for idle connection time
    double lvdown,vdown; 
    QSystemTrayIcon *trayicon;
	  QMenu *stmenu ;
	  QIcon icon;   
          QAction *startAction;
          QAction *stopAction;
          QAction *minimizeAction;
     QAction *maximizeAction;
     QAction *restoreAction;
     QAction *quitAction;
     void create_sys_tray();
     void create_msg_box();
//
       QStringList list;
       int row,column,rowcount;
       QTableWidgetItem *newItem;
       QTableWidgetItem * clickeditem;
       QList<QTableWidgetItem *> itemlist;
       netthread nthread;
    
private slots:
    void addClick();
    void addShut();
    void addExit();
    void addPkill();
    void chgconok();
    void chgconcut();

    void addSave();
    void addReset();
    void initshut(QString);
    void itemclicked(QTableWidgetItem * );
    //void iconActivated(QSystemTrayIcon::ActivationReason reason);
    void tray_icon_click(QSystemTrayIcon::ActivationReason areason);
    void tabactive(int);
    //
    void ntmap_refresh(const QStringList list);
        void fileendslot();


    
    


};
#endif




